#!/usr/bin/perl -w

require '/var/smoothwall/header.pl';

my %pppsettings;
my %temppppsettings;
my @profilenames;

my $maxprofiles = 5;

print "Content-type: text/html\n\n";

$pppsettings{'ACTION'} = '';
$pppsettings{'VALID'} = '';

$pppsettings{'PROFILENAME'} = '';

$pppsettings{'COMPORT'} = '';
$pppsettings{'DTERATE'} = '';
$pppsettings{'TELEPHONE'} = '';
$pppsettings{'SPEAKER'} = 'off';
$pppsettings{'DAILMODE'} = '';
$pppsettings{'MAXRETRIES'} = '';
$pppsettings{'TIMEOUT'} = '';
$pppsettings{'PERSISTANT'} = 'off';

$pppsettings{'USERNAME'} = '';
$pppsettings{'PASSWORD'} = '';
$pppsettings{'AUTH'} = '';
$pppsettings{'LOGINSCRIPT'} = '';

$pppsettings{'DNS'} = '';
$pppsettings{'DNS1'} = '';
$pppsettings{'DNS2'} = '';

&getcgihash(\%pppsettings);

my $errormessage = '';

if ($pppsettings{'ACTION'} eq 'Save')
{
	if ($pppsettings{'PROFILENAME'} eq '') {
		$errormessage = 'Profile name not given.';
		goto ERROR; }

	if ($pppsettings{'TELEPHONE'} eq '') {
		$errormessage = 'Telephone not set.'; 
		goto ERROR; }
	if (!($pppsettings{'TELEPHONE'} =~ /^[\d\*\#]+$/)) {
		$errormessage = 'Bad characters in the telephone number field.';
		goto ERROR; }
	if ($pppsettings{'USERNAME'} eq '') {
		$errormessage = 'Username not set'; 
		goto ERROR; }
	if ($pppsettings{'USERNAME'} =~ / /) {
		$errormessage = 'Spaces not allowed in the username field.';
		goto ERROR; }
	if ($pppsettings{'PASSWORD'} eq '') {
		$errormessage = 'Password not set.';
		goto ERROR; }
	if ($pppsettings{'PASSWORD'} =~ / /) {
		$errormessage = 'Spaces not allowed in the password field.';
		goto ERROR; }

	if ($pppsettings{'TIMEOUT'} eq '') {
		$errormessage = 'Idle timeout not set.';
		goto ERROR; }
	if (!($pppsettings{'TIMEOUT'} =~ /^\d+$/)) {
                $errormessage = 'Only digits allowed in the idle timeout.';
		goto ERROR; }

	if ($pppsettings{'LOGINSCRIPT'} =~ /[.\/ ]/ ) {
		$errormessage = 'Bad characters in script field.'; 
		goto ERROR; }

        if ($pppsettings{'DNS1'})
        {
                if (!($pppsettings{'DNS1'} =~ /^\d+\.\d+\.\d+\.\d+$/)) {
                        $errormessage = 'Invalid primary DNS.';
			goto ERROR;  }
        }
        if ($pppsettings{'DNS2'})
        {
                if (!($pppsettings{'DNS2'} =~ /^\d+\.\d+\.\d+\.\d+$/)) {
                        $errormessage = 'Invalid secondary DNS.';
			goto ERROR; }
        }

	if ($pppsettings{'MAXRETRIES'} eq '') {
		$errormessage = 'Max retries not set.';
		goto ERROR; }
	if (!($pppsettings{'MAXRETRIES'} =~ /^\d+$/)) {
		$errormessage = 'Only digits allowed in max retries field.';
		goto ERROR; }

ERROR:
	if ($errormessage) {
		$pppsettings{'VALID'} = 'no'; }
	else {
		$pppsettings{'VALID'} = 'yes'; }

	# write cgi vars to the file.
	&writehash("${swroot}/ppp/settings-$pppsettings{'PROFILE'}",
		\%pppsettings);

	# make link and write secret file.
	&updatesettings();
	&writesecrets();

	&log("Profile $pppsettings{'PROFILENAME'} saved.");
}
elsif ($pppsettings{'ACTION'} eq 'Select')
{
	%temppppsettings = ();
	$temppppsettings{'PROFILE'} = '';
	&readhash("${swroot}/ppp/settings-$pppsettings{'PROFILE'}",
		\%temppppsettings);

	if ($temppppsettings{'PROFILE'} ne '')
	{
		# make link.
		&updatesettings(); 

		# read in the new params "early" so we can write secrets.
		%pppsettings = ();
		&readhash("${swroot}/ppp/settings", \%pppsettings);

		&writesecrets();

		&log("Profile $pppsettings{'PROFILENAME'} made current profile."); 
	}
	else
	{
		$errormessage = "The selected profile is empty.";
		%pppsettings = ();		 
		$pppsettings{'VALID'} = '';	 
		&readhash("${swroot}/ppp/settings", \%pppsettings);
	}		
}
elsif ($pppsettings{'ACTION'} eq 'Delete')
{
	&log("Profile $pppsettings{'PROFILENAME'} deleted.");

	truncate ("${swroot}/ppp/settings-$pppsettings{'PROFILE'}", 0);
	%pppsettings = ();
	$pppsettings{'VALID'} = '';
	&readhash("${swroot}/ppp/settings", \%pppsettings);			
}
else
{
	# read in the current vars
	%pppsettings = ();
	$pppsettings{'VALID'} = '';
	&readhash("${swroot}/ppp/settings", \%pppsettings);
}

# read in the profile names into @profilenames.
for ($c = 1; $c <= $maxprofiles; $c++)
{
 	%temppppsettings = ();
	$temppppsettings{'PROFILENAME'} = 'Empty';
	&readhash("${swroot}/ppp/settings-$c", \%temppppsettings);
	$profilenames[$c] = $temppppsettings{'PROFILENAME'};
}

if ($pppsettings{'VALID'} eq '')
{
	$pppsettings{'PROFILE'} = 1;
	$pppsettings{'PROFILENAME'} = 'Unnamed';
	$pppsettings{'COMPORT'} = 'ttyS0';
	$pppsettings{'DTERATE'} = 115200;
	$pppsettings{'SPEAKER'} = 'on';
	$pppsettings{'PERSISTANT'} = 'off';
	$pppsettings{'DIALMODE'} = 'T';
	$pppsettings{'MAXRETRIES'} = 10;
	$pppsettings{'TIMEOUT'} = 15;
	$pppsettings{'AUTH'} = 'pap-or-chap';
	$pppsettings{'DNS'} = 'Automatic';
}

for ($c = 1; $c <= $maxprofiles; $c++) {
	$selected{'PROFILE'}{'$c'} = ''; }
$selected{'PROFILE'}{$pppsettings{'PROFILE'}} = 'SELECTED';

$selected{'COMPORT'}{'ttyS0'} = '';
$selected{'COMPORT'}{'ttyS1'} = '';
$selected{'COMPORT'}{'ttyS2'} = '';
$selected{'COMPORT'}{'ttyS3'} = '';
$selected{'COMPORT'}{$pppsettings{'COMPORT'}} = 'SELECTED';

$selected{'DTERATE'}{'9600'} = '';
$selected{'DTERATE'}{'19200'} = '';
$selected{'DTERATE'}{'38400'} = '';
$selected{'DTERATE'}{'57600'} = '';
$selected{'DTERATE'}{'115200'} = '';
$selected{'DTERATE'}{$pppsettings{'DTERATE'}} = 'SELECTED';

$checked{'SPEAKER'}{'off'} = '';
$checked{'SPEAKER'}{'on'} = '';
$checked{'SPEAKER'}{$pppsettings{'SPEAKER'}} = 'CHECKED';

$selected{'DIALMODE'}{'T'} = '';
$selected{'DIALMODE'}{'P'} = '';
$selected{'DIALMODE'}{$pppsettings{'DIALMODE'}} = 'SELECTED';

$checked{'PERSISTANT'}{'off'} = '';
$checked{'PERSISTNAT'}{'on'} = '';
$checked{'PERSISTANT'}{$pppsettings{'PERSISTANT'}} = 'CHECKED';

$selected{'AUTH'}{'pap-or-chap'} = '';
$selected{'AUTH'}{'standard-login-script'} = '';
$selected{'AUTH'}{'demon-login-script'} = '';
$selected{'AUTH'}{'other-login-script'} = '';
$selected{'AUTH'}{$pppsettings{'AUTH'}} = 'SELECTED';

$checked{'DNS'}{'Automatic'} = '';
$checked{'DNS'}{'Manual'} = '';
$checked{'DNS'}{$pppsettings{'DNS'}} = 'CHECKED';

&openpage('PPP setup', 1);

&openbigbox('100%', 'LEFT');

print "<FORM METHOD='POST'>\n";

&openbox('100%', 'LEFT', 'Profiles:');

print <<END
<TABLE WIDTH='100%'>
<TR>
	<TD>
	<SELECT NAME='PROFILE'>
END
;
for ($c = 1; $c <= $maxprofiles; $c++)
{
	print "\t<OPTION VALUE='$c' $selected{'PROFILE'}{$c}>$profilenames[$c]\n";
}
print <<END
	</SELECT>
	</TD>
	<TD><INPUT TYPE='submit' NAME='ACTION' VALUE='Select'></TD>
	<TD><INPUT TYPE='submit' NAME='ACTION' VALUE='Delete'></TD>
	<TD>Profile name: </TD>
        <TD><INPUT TYPE='text' NAME='PROFILENAME' VALUE='$pppsettings{'PROFILENAME'}'></TD>
</TR>
</TABLE>
END
;

&closebox();

&openbox('100%', 'LEFT', 'Telephony:');
print <<END
<TABLE WIDTH='100%'>
<TR>
	<TD>Interface: </TD>
	<TD>
	<SELECT NAME='COMPORT'>
	<OPTION VALUE='ttyS0' $selected{'COMPORT'}{'ttyS0'}>Modem on COM1
	<OPTION VALUE='ttyS1' $selected{'COMPORT'}{'ttyS1'}>Modem on COM2
	<OPTION VALUE='ttyS2' $selected{'COMPORT'}{'ttyS2'}>Modem on COM3
	<OPTION VALUE='ttyS3' $selected{'COMPORT'}{'ttyS3'}>Modem on COM4
	</SELECT>
	</TD>
	<TD>Computer to modem rate: </TD>
	<TD>
	<SELECT NAME='DTERATE'>
	<OPTION VALUE='9600' $selected{'DTERATE'}{'9600'}>9600
	<OPTION VALUE='19200' $selected{'DTERATE'}{'19200'}>19200
	<OPTION VALUE='38400' $selected{'DTERATE'}{'38400'}>38400
	<OPTION VALUE='57600' $selected{'DTERATE'}{'57600'}>57600
	<OPTION VALUE='115200' $selected{'DTERATE'}{'115200'}>115200
	</SELECT>
	</TD>
</TR>
<TR>
	<TD>Number: </TD>
	<TD><INPUT TYPE='text' NAME='TELEPHONE' VALUE='$pppsettings{'TELEPHONE'}'></TD>
	<TD>Modem speaker on: </TD>
	<TD><INPUT TYPE='checkbox' NAME='SPEAKER' VALUE='on' $checked{'SPEAKER'}{'on'}></TD>
</TR>
<TR>
	<TD>Dialing mode: </TD>
	<TD>
	<SELECT NAME='DIALMODE'>
	<OPTION VALUE='T' $selected{'DIALMODE'}{'T'}>Tone
	<OPTION VALUE='P' $selected{'DIALMODE'}{'P'}>Pulse
	</SELECT>
	</TD>
	<TD>Maximum retries: </TD>
	<TD><INPUT TYPE='text' NAME='MAXRETRIES' VALUE='$pppsettings{'MAXRETRIES'}'></TD>
</TR>
<TR>
	<TD>Idle timeout (mins; 0 to disable): </TD>
	<TD><INPUT TYPE='text' NAME='TIMEOUT' VALUE='$pppsettings{'TIMEOUT'}'></TD>
	<TD>Persistant connection: </TD>
	<TD><INPUT TYPE='checkbox' NAME='PERSISTANT' VALUE='on' $checked{'PERSISTANT'}{'on'}></TD>
</TR>
</TABLE>
END
;

&closebox();

&openbox('100%', 'LEFT', 'Authentication:');
print <<END
<TABLE WIDTH='100%'>
<TR>
	<TD>Username: </TD>
	<TD><INPUT TYPE='text' NAME='USERNAME' VALUE='$pppsettings{'USERNAME'}'></TD>
	<TD>Password: </TD>
	<TD><INPUT TYPE='password' NAME='PASSWORD' VALUE='$pppsettings{'PASSWORD'}'></TD>
</TR>
<TR>
	<TD>Method: </TD>
	<TD>
	<SELECT NAME='AUTH'>
	<OPTION VALUE='pap-or-chap' $selected{'AUTH'}{'pap-or-chap'}>PAP or CHAP
	<OPTION VALUE='standard-login-script' $selected{'AUTH'}{'standard-login-script'}>Standard login script
	<OPTION VALUE='demon-login-script' $selected{'AUTH'}{'demon-login-script'}>Demon login script
	<OPTION VALUE='other-login-script' $selected{'AUTH'}{'other-login-script'}>Other login script
	</SELECT>
	</TD>
	<TD>Script name: </TD>
	<TD><INPUT TYPE='text' NAME='LOGINSCRIPT' VALUE='$pppsettings{'LOGINSCRIPT'}'></TD>
</TR>
</TABLE>
END
;
&closebox();

&openbox('100%', 'LEFT', 'DNS:');
print <<END
<TABLE WIDTH='100%'>
<TR>
	<TD>Type: </TD>
	<TD COLSPAN=3>
	<INPUT TYPE='radio' NAME='DNS' VALUE='Manual' $checked{'DNS'}{'Manual'}>Manual
	<INPUT TYPE='radio' NAME='DNS' VALUE='Automatic' $checked{'DNS'}{'Automatic'}>Automatic
	</TD>
</TR>
<TR>
<TD>Primary DNS: </TD>
<TD><INPUT TYPE='text' NAME='DNS1' VALUE='$pppsettings{'DNS1'}'></TD>
<TD>Secondary DNS: </TD>
<TD><INPUT TYPE='text' NAME='DNS2' VALUE='$pppsettings{'DNS2'}'></TD>
</TR>
</TABLE>
END
;
&closebox();
	
&openbox('100%', 'LEFT', 'Error messages:');
print "$errormessage\n";
print "&nbsp;\n";
&closebox();

print <<END
<DIV ALIGN='CENTER'>
<TABLE WIDTH='80%'>
<TR>
	<TD ALIGN='CENTER'><INPUT TYPE='submit' NAME='ACTION' VALUE='Save'></TD>
	<TD ALIGN='CENTER'><INPUT TYPE='submit' NAME='ACTION' VALUE='Restore'></TD>
	<TD ALIGN='CENTER'><A HREF='/cgi-bin/index.cgi'>BACK</A></TD>
	<TD ALIGN='CENTER'><A HREF='/configure.html#3.1.'>HELP</A></TD>
</TR>
</TABLE>
</DIV>
END
;

print "</FORM>\n";

&closebigbox();

&closepage();

sub updatesettings
{
	# make a link from the selected profile to the "default" one.
 	unlink("${swroot}/ppp/settings");
	link("${swroot}/ppp/settings-$pppsettings{'PROFILE'}",
		"${swroot}/ppp/settings");
}

sub writesecrets
{
	# write secrets file.
	open(FILE, ">/${swroot}/ppp/secrets") or die "Unable to write secrets file.";
	$username = $pppsettings{'USERNAME'};
	$password = $pppsettings{'PASSWORD'};
        print FILE "$username * $password\n";
        close FILE;
}

